//fichier qui ralise les fonctions d'attente

#include	"delay.h"

unsigned char i;

void DelayS(unsigned char nbr)
{
	//avec un quartz a 4mhz, on doit attendre 1 000 000 instructions
	while(nbr)
	{
		Delay100K(10);
		nbr--;
	}
}

void DelayMS(unsigned char nbr)
{
	//on doit attendre 10 000 instructions
	while(nbr)
	{
		Delay10K(1);
		nbr--;
	}
}

void Delay1332US(void)
{
	//tempo de 1332US pour la reception RC5
	//on doit attendre 1332 instructions
	Delay1K(1);
	Delay100(3);
	Delay10(2);
	#asm
	nop
	#endasm
}

void Delay10(unsigned char nbr)
{
	while(nbr)
	{
		#asm
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		#endasm
		nbr--;
	}
}

void Delay100(unsigned char nbr)
{
	while(nbr)
	{
		#asm
		movlw 0x13
		movwf _i
		delay2:
		nop
		decfsz _i,F
		goto delay2
		nop
		nop
		nop
		#endasm
		nbr--;
	}
}

void Delay1K(unsigned char nbr)
{
	while(nbr)
	{
		#asm
		movlw 0xf8
		movwf _i
		delay1:
		nop
		decfsz _i,F
		goto delay1
		#endasm
		nbr--;
	}
}

void Delay10K(unsigned char nbr)
{
	while(nbr)
	{
		Delay1K(10);
		nbr--;
	}
}

void Delay100K(unsigned char nbr)
{
	while(nbr)
	{
		Delay1K(100);
		nbr--;
	}
}
