#include "delay.h"
#include <pic.h>
#include "main.h"
#include "preamp.h"
#include "rc5.h"
#include "eeprom.h"


//Config
	__CONFIG(WDTDIS & XT & UNPROTECT);
//On met la premire valeur de l'eprom a zero
	__EEPROM_DATA(0,0,0,0,0,0,0,0);

//Variables
bit PreampAllume;
bit TrameRc5;
bit AppuiBouton;
unsigned char valeur_eprom;

/* Fonction principale. Elle xecute la boucle principale */
void main()
{
	/* On fait la configuration matrielle du pic */
	TRISA = 0b00000000;		//PortA en sortie
	TRISB = 0b11111111;		//PortB en entre
	OPTION = 0b00000111; 	//Configuration des options
							//Pull-up activ
							//Interruption sur front montant
							//Timer interne
							//non utilis, diviseur sur le timer
							//diviseur = 1/256
	INTCON = 0b00011000;	//Configuration des interruptions, rb0 activ, rbie activ
	
	//Initialisation des variables
	PreampAllume = 0;

	//RAZ
	PORTB = 0;
	PORTA = 0;

	//On vient lire la valeur renseigne en eeprom
	valeur_eprom = EEPROM_READ(0x00);

	while(1)
	{
		/* On scrute les ports */
		scrutation();
	}
}

void scrutation()
{
	/* Cette fonction va permettre de scruter le bouton power et 
		Le recepteur infrarouge et de dclencher les actions correspondantes */

	/* 0n scrute le recepteur infrarouge */
	/* Si il est a zero (signal a un), on declenche la reception */
	if(!IR)
	{
		/* On fait la reception */
		reception_rc5();
	
		/* On dclenche le traitement */
		traitement_rc5();
	}

	/* On regarde l'tat du poussoir , on declenche si il est a zero */
	if(!BOUTON)
	{
		/* On declenche l'action correspondante */
		if(PreampAllume)
			extinction_preampli();
		else
			allumage_preampli();
	}
}
