/* Ce fichier va contenir les fonctions qui permettent de grer le pramplificateur */

#include "delay.h"
#include <pic.h>
#include "preamp.h"
#include "main.h"



extern bit PreampAllume;


void allumage_preampli()
{
	/* Cette fonction va servir a mettre le preampli en fonction */
	
	//On active l'alimentation
	ALIM = 1;
	
	//On attend cinq seconde
	DelayS(5);

	//on positionne le trigger
	TRIGGER = 1;

	//On dclare le preampli allum
	PreampAllume = 1;

	//On attend 2 secondes avant de rendre la main
	DelayS(2);
}

void extinction_preampli()
{
	/* Cette fonction va permettre d'teindre le preampli */

	//On coupe le trigger
	TRIGGER = 0;

	//On coupe l'alimentation
	ALIM = 0;

	//le preamp est eteint
	PreampAllume = 0;

	//On attend 2 sec avant de rendre la main
	DelayS(2);
}

void volume_plus()
{
	/* Cette fonction permet d'augmenter le volume du prampli */
	/* pour cela, on fait tourner le potar pendant une seconde */

	/* On positionne le sens de rotation */
	POTARPLUS = 1;
	POTARMOINS = 0;
	
	/* On active la sortie */
	POTAR_EN = 1;

	/* On attend 20Ms */
	DelayMS(20);

	/* On eteint le potar */
	POTAR_EN = 0;
}

void volume_moins()
{
	/* Cette fonction permet de diminuer le volume du prampli */
	/* Pour cela, on fait tourner le potar pendant une seconde */

	/* On positionne le sens de rotation */
	POTARPLUS = 0;
	POTARMOINS = 1;

	POTAR_EN = 1;

	/* On attend 20ms seconde */
	DelayMS(20);

	/* on eteint le potar */
	POTAR_EN = 0;
}
