/* Ce fichier va tre charg de regrouper toutes les commandes */
/* qui vont grer la rception infrarouge par le pic */

#include "delay.h"
#include <pic.h>
#include "rc5.h"
#include "main.h"
#include "preamp.h"

unsigned char code,commande;
bit repeat;
extern bit PreampAllume;
extern unsigned char valeur_eprom;

void reception_rc5(void)
{
	//Cette fonction va effectuer la rception rc5
	//elle renseigne le code appareil et le code commande recu

	unsigned char NbBits;

	//On met les codes a zero
	code = 0;
	commande = 0;
	repeat = 0;

	//On attend que le signal passe a zero (IR a un)
	while(!IR) {}

	//Second bit de start
	//on attend le prochain front
	RC5WaitBit(!IR);
	//On attend 1332uS, 3/4 bit
	Delay1332US();
	
	//on lit la rptition
	if(IR) repeat = 1;
	RC5WaitBit(!IR);
	Delay1332US();
	
	//on recoit les 5 bits du code
	NbBits = 5;
	while(NbBits)
	{
		//On dcale a gauche
		code = code << 1;

		if(IR) code = code | 0b00000001;
		RC5WaitBit(!IR);
		Delay1332US();
		NbBits--;
	}

	//Reception de la commande
	NbBits = 6;
	while(NbBits)
	{
		commande = commande <<1;

		if(IR) commande = commande | 0b00000001;
		RC5WaitBit(!IR);
		Delay1332US();
		NbBits--;
	}

	Delay1332US();
	Delay1332US();
}

void RC5WaitBit(unsigned char code)
{
	//cette fonction va permettre d'attendre le prochain front

	unsigned char i,j;

	//boucle, qui permet d'viter de bloquer le pic en cas de mauvaise reception
	for(i=0x2D; i!=0; i--)
	{
		//tempo	
		for(j=0x20;j!=0;j--) {}
		
		//on vient lire le port IR
		if(code == IR) return;	//on a trouv un changement de valeur
	}
}

void traitement_rc5()
{
	/* Cette fonction va permettre d'xecuter une action selon */
	/* Ce qui a t recu en rc5 */

	//Si la valeur lue en eeprom est gale a zero, on fait l'auto apprentissage.
//	if (RB6 == 0)
	if (valeur_eprom == 0)
	{
		//On crit la valeur du code reu
		EEPROM_WRITE(0x00,code);
		//On fait la maj de la variable
		valeur_eprom = code;
	}

	//on place l'adresse sur porta
	//PORTA = adresse;

	/* Si l'addresse est bonne (20) */
//	if (code == valeur_eprom)
	if (code == 0x14)
	{
		//Seulement si le preamp est allum
		if(PreampAllume)
		{
			/* Si le code est 0x10 (vol+) */
			if (commande == 0x10)	
				volume_plus();

			/* Si c'est 0x11 (vol-) */
			if (commande == 0x11)
				volume_moins();
		}
		
		/* Si le code est 0xC (power) */
		if (commande == 0xC)
		{
			if(PreampAllume)
				extinction_preampli();
			else
				allumage_preampli();
		}
	}
}
